'' Program for testing cog interactions
''
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ

  text    : "tv_text"

VAR

  long SharePtr1
  long Count1

  long SharePtr2
  long Count2

  long SharePtr3
  long Count3

  long SharedCount

  long Count1A
  long Count1B
  long Count2A
  long Count2B
  long Count3A
  long Count3B
  
  
PUB Init

  ' We'll use the TV for debug output
  text.start(12)
  text.str(string("Starting Cog Test", 13))

  SharePtr1 := @SharedCount
  SharePtr2 := @SharedCount
  SharePtr3 := @SharedCount

  start(@SharePtr1)
  start(@SharePtr2)
  start(@SharePtr3)
  
  repeat

    ' Determine how many times looped during wait time.
    Count1A := Count1
    Count2A := Count2
    Count3A := Count3
    waitcnt(10_000_000 + cnt)
    Count1B := Count1
    Count2B := Count2
    Count3B := Count3
    
    text.str(string("X: "))
    text.hex(Count1B - Count1A, 8)
    text.str(string("  Y: "))
    text.hex(Count2B - Count2A, 8)
    text.str(string("  Z: "))
    text.hex(Count3B - Count3A, 8)
    text.str(string(13))

    
   

PRI start(ptr)

  cognew(@entry, ptr)

DAT

'*****************************************
'* Assembly language Sand Physics Engine *
'*****************************************

                        org
'
'
' Entry
'
entry                   mov ptrs,par
                        rdlong share_ptr, ptrs
                        add ptrs, #4
                        mov count_ptr, ptrs

:loop
                        add ctr, #1
                        wrlong ctr, count_ptr

                        ' Contend for read access to shared memory
                        rdlong share_num, share_ptr
                        rdlong share_num, share_ptr
                        rdlong share_num, share_ptr
                        rdlong share_num, share_ptr
                        rdlong share_num, share_ptr
                        rdlong share_num, share_ptr
                        rdlong share_num, share_ptr
                        rdlong share_num, share_ptr
                        rdlong share_num, share_ptr

                        ' Change value from shared memory
                        add share_num, #1

                        ' Conted for write access to shared memory
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        wrlong share_num, share_ptr
                        jmp #:loop
                        

zero    long  0
neg1    long  -1
Nil     long  0
T       long  -1
ctr   long  1

'
'
' Uninitialized data
'

' DLF
ptrs                    res     1
count_ptr               res     1
share_ptr               res     1
share_num               res     1